#!/bin/bash

############################
# zephirlogs.sh
# instructions spécifiques
# au module ZephirLogs
############################
#    Main
if [ -x /usr/share/eole/FonctionsEoleNg ]; then
. /usr/share/eole/FonctionsEoleNg
else
        echo 'Erreur : FonctionsEoleNg non trouvé'
        exit 1
fi

if [ -x /usr/bin/ParseDico ]; then
. /usr/bin/ParseDico
else
	echo 'Erreur : ParseDico non trouvé'
	exit 1
fi

if [ "$activer_log_distant" == "oui" -o "$activate_tls" == "oui" ];then
		if [ -e /etc/ssl/ca/ca-eole-rsyslog.pem ]; then
                echo "Génération de la clé..."

                /usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-privkey --outfile /etc/ssl/private/$nom_machine-key.pem --bits 2048

                echo "Génération de la requête de signature..."

                if [ ! -d /etc/ssl/request ]; then
                        mkdir -p /etc/ssl/request
                fi

                /usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-request --load-privkey /etc/ssl/private/$nom_machine-key.pem --outfile /etc/ssl/request/$nom_machine-rsyslog-request.pem

                echo "Génération du couple clé/certificat signé..."
                if [ ! -d /etc/ssl/certs ]; then
                        mkdir -p /etc/ssl/certs
                fi

                /usr/bin/certtool --template /etc/ssl/eole-client-template.cnf --generate-certificate --load-request /etc/ssl/request/$nom_machine-rsyslog-request.pem --outfile /etc/ssl/certs/$nom_machine-rsyslog-cert.pem --load-ca-certificate /etc/ssl/ca/ca-eole-rsyslog.pem --load-ca-privkey /etc/ssl/private/ca-eole-rsyslog-key.pem

		else
		echo "Fichier CA de rsyslog non trouvé, merci de le transférer dans le répertoire /etc/ssl/ca"
		fi
fi

# lancement du serveur d'enregistrement prelude-manager
echo "Voulez-vous lancer le serveur d'enregistrement prelude en tâche de fond ? (O/N)"
read answer
if [ "$answer" == "O" ]; then
        if [ -e /usr/share/eole/prelude-registration ]; then
                rm -f /usr/share/eole/prelude-registration
        fi
        /usr/bin/pwgen -1 > /usr/share/eole/prelude-registration
        /bin/pidof prelude-admin > /dev/null
        if [ "$?" == "0" ]; then
                /usr/bin/prelude-admin registration-server prelude-manager --keepalive --no-confirm --passwd-file=/usr/share/eole/prelude-registration &
        else
                kill -9 `/bin/pidof prelude-admin`
                /usr/bin/prelude-admin registration-server prelude-manager --keepalive --no-confirm --passwd-file=/usr/share/eole/prelude-registration &
        fi
fi

## Creation du nouveau mot de passe root mysql
pass_root=`/usr/bin/pwgen -1`
/usr/share/eole/mysql_pwd.py "$pass_root" nomodif >/dev/null

## PrelugeManager
echo
if [ -x "/usr/bin/prelude-admin" ]; then
        echo "Création de l'utilisateur prelude-manager"
        /usr/bin/prelude-admin add prelude-manager --uid prelude --gid prelude
        /usr/bin/prelude-admin chown prelude-manager --uid prelude --gid prelude
else
        echo "Erreur pas de programme prelude-admin !"
fi

if [ ! -f /var/lib/mysql/prelude/db.opt ]
then
        if [ -f /usr/share/libpreludedb/classic/mysql.sql ]
        then
                mysql -u root --password=$pass_root -e "create database prelude;"
                mysql -u root --password=$pass_root prelude < /usr/share/libpreludedb/classic/mysql.sql
                mysql -u root --password=$pass_root -e "grant select,insert,update,delete,alter ON prelude.* TO prelude@localhost IDENTIFIED BY 'prelude';"
        fi
fi

## PREWIKKA
if [ ! -f /var/lib/mysql/prewikka/db.opt ]
then
        if [ -f /usr/share/dbconfig-common/data/prewikka/install/mysql ]
        then
                mysql -u root --password=$pass_root -e "create database prewikka;"
                mysql -u root --password=$pass_root prewikka < /usr/share/dbconfig-common/data/prewikka/install/mysql
                mysql -u root --password=$pass_root -e "grant select,insert,update,delete,alter ON prewikka.* TO prewikka@localhost IDENTIFIED BY 'prewikka';"
        fi
fi

echo
# synchro des mots de passe
PASS=`/usr/bin/pwgen -1`
/usr/share/eole/mysql_pwd.py "$PASS"
echo
